
;CodeVisionAVR C Compiler V3.48a Standard
;(C) Copyright 1998-2022 Pavel Haiduc, HP InfoTech S.R.L.
;http://www.hpinfotech.ro

;Build configuration    : Debug
;Chip type              : ATtiny2313
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': No
;'char' is unsigned     : No
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Mode 1
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_TINY_

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU WDTCSR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x00DF
	.EQU __DSTACK_SIZE=0x0020
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.EQU __FLASH_PAGE_SIZE=0x10
	.EQU __EEPROM_PAGE_SIZE=0x04

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETW1P
	LD   R30,X+
	LD   R31,X
	DEC  R26
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETD1P_INC
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	.ENDM

	.MACRO __GETD1P_DEC
	LD   R23,-X
	LD   R22,-X
	LD   R31,-X
	LD   R30,-X
	.ENDM

	.MACRO __PUTDP1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTDP1_DEC
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __CPD10
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	.ENDM

	.MACRO __CPD20
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	.ENDM

	.MACRO __ADDD12
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	.ENDM

	.MACRO __ADDD21
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	.ENDM

	.MACRO __SUBD12
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	.ENDM

	.MACRO __SUBD21
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	.ENDM

	.MACRO __ANDD12
	AND  R30,R26
	AND  R31,R27
	AND  R22,R24
	AND  R23,R25
	.ENDM

	.MACRO __ORD12
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	.ENDM

	.MACRO __XORD12
	EOR  R30,R26
	EOR  R31,R27
	EOR  R22,R24
	EOR  R23,R25
	.ENDM

	.MACRO __XORD21
	EOR  R26,R30
	EOR  R27,R31
	EOR  R24,R22
	EOR  R25,R23
	.ENDM

	.MACRO __COMD1
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	.ENDM

	.MACRO __MULD2_2
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	.ENDM

	.MACRO __LSRD1
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	.ENDM

	.MACRO __LSLD1
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	.ENDM

	.MACRO __ASRB4
	ASR  R30
	ASR  R30
	ASR  R30
	ASR  R30
	.ENDM

	.MACRO __ASRW8
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	.ENDM

	.MACRO __LSRD16
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	.ENDM

	.MACRO __LSLD16
	MOV  R22,R30
	MOV  R23,R31
	LDI  R30,0
	LDI  R31,0
	.ENDM

	.MACRO __CWD1
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	.ENDM

	.MACRO __CWD2
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	.ENDM

	.MACRO __SETMSD1
	SER  R31
	SER  R22
	SER  R23
	.ENDM

	.MACRO __ADDW1R15
	CLR  R0
	ADD  R30,R15
	ADC  R31,R0
	.ENDM

	.MACRO __ADDW2R15
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	.ENDM

	.MACRO __EQB12
	CP   R30,R26
	LDI  R30,1
	BREQ PC+2
	CLR  R30
	.ENDM

	.MACRO __NEB12
	CP   R30,R26
	LDI  R30,1
	BRNE PC+2
	CLR  R30
	.ENDM

	.MACRO __LEB12
	CP   R30,R26
	LDI  R30,1
	BRGE PC+2
	CLR  R30
	.ENDM

	.MACRO __GEB12
	CP   R26,R30
	LDI  R30,1
	BRGE PC+2
	CLR  R30
	.ENDM

	.MACRO __LTB12
	CP   R26,R30
	LDI  R30,1
	BRLT PC+2
	CLR  R30
	.ENDM

	.MACRO __GTB12
	CP   R30,R26
	LDI  R30,1
	BRLT PC+2
	CLR  R30
	.ENDM

	.MACRO __LEB12U
	CP   R30,R26
	LDI  R30,1
	BRSH PC+2
	CLR  R30
	.ENDM

	.MACRO __GEB12U
	CP   R26,R30
	LDI  R30,1
	BRSH PC+2
	CLR  R30
	.ENDM

	.MACRO __LTB12U
	CP   R26,R30
	LDI  R30,1
	BRLO PC+2
	CLR  R30
	.ENDM

	.MACRO __GTB12U
	CP   R30,R26
	LDI  R30,1
	BRLO PC+2
	CLR  R30
	.ENDM

	.MACRO __CPW01
	CLR  R0
	CP   R0,R30
	CPC  R0,R31
	.ENDM

	.MACRO __CPW02
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	.ENDM

	.MACRO __CPD12
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	.ENDM

	.MACRO __CPD21
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	.ENDM

	.MACRO __BSTB1
	CLT
	TST  R30
	BREQ PC+2
	SET
	.ENDM

	.MACRO __LNEGB1
	TST  R30
	LDI  R30,1
	BREQ PC+2
	CLR  R30
	.ENDM

	.MACRO __LNEGW1
	OR   R30,R31
	LDI  R30,1
	BREQ PC+2
	LDI  R30,0
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD2M
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	RCALL __GETW1Z
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	RCALL __GETD1Z
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __GETW2X
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __GETD2X
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Conv_DS18B20=R3
	.DEF _CountFiveSek=R2
	.DEF _PointDig=R5
	.DEF _Teplota=R4
	.DEF _SetTemp=R7
	.DEF _SetTimer=R6
	.DEF _Timer=R9
	.DEF _ChangeNum=R8
	.DEF _RunTimer=R11
	.DEF _CountTimMin=R10
	.DEF _CountTl=R13
	.DEF _ModeRAM=R12

;GPIOR0-GPIOR2 INITIALIZATION VALUES
	.EQU __GPIOR0_INIT=0x00
	.EQU __GPIOR1_INIT=0x00
	.EQU __GPIOR2_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _pin_change_isr0
	RJMP 0x00
	RJMP _timer0_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_TableChar:
	.DB  0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8
	.DB  0x80,0x90
_TableTimer:
	.DB  0xBF,0xFB,0xF7,0xEF

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x1


__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x03
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,__CLEAR_SRAM_SIZE
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	;__GPIOR1_INIT = __GPIOR0_INIT
	OUT  GPIOR1,R30
	;__GPIOR2_INIT = __GPIOR0_INIT
	OUT  GPIOR2,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0x00

	.DSEG
	.ORG 0x80

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;void ElZero(void)
; 0000 0081 {

	.CSEG
_ElZero:
; .FSTART _ElZero
; 0000 0082 if (Digits[0]==TableChar[0])    //nezobrazenie nepodstatnch nl
	RCALL SUBOPT_0x0
	LDS  R26,_Digits
	CP   R30,R26
	BRNE _0x3
; 0000 0083 {
; 0000 0084 Digits[0]=0xFF;
	RCALL SUBOPT_0x1
; 0000 0085 if (Digits[1]==TableChar[0]) Digits[1]=0xFF;
	CP   R30,R26
	BRNE _0x4
	RCALL SUBOPT_0x2
; 0000 0086 }
_0x4:
; 0000 0087 }
_0x3:
	RET
; .FEND
;void TemperatureDisplay (void)
; 0000 008B {
_TemperatureDisplay:
; .FSTART _TemperatureDisplay
; 0000 008C unsigned char Temp;     //doasn premmen
; 0000 008D if (Teplota>=200) Temp=Teplota-200, Digits[0]=TableChar[2];     //zistenie i je teplota vyia ako 100C, prprava dt na 1 displeji
	ST   -Y,R17
;	Temp -> R17
	LDI  R30,LOW(200)
	CP   R4,R30
	BRLO _0x5
	MOV  R30,R4
	SUBI R30,LOW(200)
	MOV  R17,R30
	__POINTW1FN _TableChar,2
	RCALL SUBOPT_0x3
; 0000 008E else if (Teplota>=100) Temp=Teplota-100, Digits[0]=TableChar[1];
	RJMP _0x6
_0x5:
	LDI  R30,LOW(100)
	CP   R4,R30
	BRLO _0x7
	MOV  R30,R4
	SUBI R30,LOW(100)
	MOV  R17,R30
	__POINTW1FN _TableChar,1
	RCALL SUBOPT_0x3
; 0000 008F else Digits[0]=TableChar[0], Temp=Teplota;
	RJMP _0x8
_0x7:
	LDI  R30,LOW(_TableChar*2)
	LDI  R31,HIGH(_TableChar*2)
	RCALL SUBOPT_0x3
	MOV  R17,R4
; 0000 0090 Temp=bin2bcd(Temp);  //prevod binrnej informcie teploty na BCD
_0x8:
_0x6:
	MOV  R26,R17
	RCALL _bin2bcd
	RCALL SUBOPT_0x4
; 0000 0091 Digits[1]=TableChar[Temp>>4];   //prprava desiatok teploty
; 0000 0092 Digits[2]=TableChar[Temp&0x0F]; //prprava jednotiek teploty
; 0000 0093 ElZero();       //Elimincia nepodstatnch nl
	RCALL _ElZero
; 0000 0094 if (F_NegTemp)                               //zobrazenie znaku "-" ke je mnusov teplota
	SBIS 0x13,3
	RJMP _0x9
; 0000 0095 {
; 0000 0096 if (Digits[1]==0xFF) Digits[1]=CharE;
	__GETB2MN _Digits,1
	CPI  R26,LOW(0xFF)
	BRNE _0xA
	LDI  R30,LOW(191)
	__PUTB1MN _Digits,1
; 0000 0097 else Digits[0]=CharE;
	RJMP _0xB
_0xA:
	LDI  R30,LOW(191)
	RCALL SUBOPT_0x5
; 0000 0098 }
_0xB:
; 0000 0099 }
_0x9:
	RJMP _0x2020001
; .FEND
;void SetTemperatureDisplay(void)
; 0000 009D {
_SetTemperatureDisplay:
; .FSTART _SetTemperatureDisplay
; 0000 009E unsigned char Temp;     //doasn premmen
; 0000 009F Temp=bin2bcd(ChangeNum);  //prevod binrnej informcie teploty na BCD
	ST   -Y,R17
;	Temp -> R17
	MOV  R26,R8
	RCALL _bin2bcd
	MOV  R17,R30
; 0000 00A0 Digits[0]=TableChar[0];         //
	LDI  R30,LOW(_TableChar*2)
	LDI  R31,HIGH(_TableChar*2)
	RCALL SUBOPT_0x3
; 0000 00A1 Digits[1]=TableChar[Temp>>4];   //prprava desiatok teploty
	MOV  R30,R17
	SWAP R30
	ANDI R30,0xF
	RCALL SUBOPT_0x6
	__PUTBR0MN _Digits,1
; 0000 00A2 Digits[2]=TableChar[Temp&0x0F]; //prprava jednotiek teploty
	MOV  R30,R17
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0x6
	__PUTBR0MN _Digits,2
; 0000 00A3 ElZero();       //Elimincia nepodstatnch nl
	RCALL _ElZero
; 0000 00A4 if (Digits[0]==TableChar[0])    //nezobrazenie nepodstatnch nl
	RCALL SUBOPT_0x0
	LDS  R26,_Digits
	CP   R30,R26
	BRNE _0xC
; 0000 00A5 {
; 0000 00A6 Digits[0]=0xFF;
	RCALL SUBOPT_0x1
; 0000 00A7 if (Digits[1]==TableChar[0]) Digits[1]=0xFF;
	CP   R30,R26
	BRNE _0xD
	RCALL SUBOPT_0x2
; 0000 00A8 }
_0xD:
; 0000 00A9 }
_0xC:
	RJMP _0x2020001
; .FEND
;void TimerDisplay(unsigned char Num)
; 0000 00AD {
_TimerDisplay:
; .FSTART _TimerDisplay
; 0000 00AE unsigned char Temp;     //doasn premmen
; 0000 00AF Temp=bin2bcd(Num);  //prevod binrnej informcie teploty na BCD
	ST   -Y,R26
	ST   -Y,R17
;	Num -> Y+1
;	Temp -> R17
	LDD  R26,Y+1
	RCALL _bin2bcd
	RCALL SUBOPT_0x4
; 0000 00B0 Digits[1]=TableChar[Temp>>4];   //prprava desiatok teploty
; 0000 00B1 Digits[2]=TableChar[Temp&0x0F]; //prprava jednotiek teploty
; 0000 00B2 //ElZero();       //Elimincia nepodstatnch nl
; 0000 00B3 if (Digits[1]==TableChar[0]) Digits[1]=0xFF;  //nezobrazenie znaku ke je nula
	__GETB2MN _Digits,1
	RCALL SUBOPT_0x0
	CP   R30,R26
	BRNE _0xE
	RCALL SUBOPT_0x2
; 0000 00B4 if (F_Timer)
_0xE:
	SBIS 0x13,6
	RJMP _0xF
; 0000 00B5 {
; 0000 00B6 Digits[0]=TableTimer[RunTimer];
	MOV  R30,R11
	LDI  R31,0
	SUBI R30,LOW(-_TableTimer*2)
	SBCI R31,HIGH(-_TableTimer*2)
	RCALL SUBOPT_0x3
; 0000 00B7 }
; 0000 00B8 else Digits[0]=Char_o;         //
	RJMP _0x10
_0xF:
	LDI  R30,LOW(163)
	RCALL SUBOPT_0x5
; 0000 00B9 }
_0x10:
	LDD  R17,Y+0
	ADIW R28,2
	RET
; .FEND
;void RefreshDisplay (void)
; 0000 00BE {
_RefreshDisplay:
; .FSTART _RefreshDisplay
; 0000 00BF unsigned char Temp;
; 0000 00C0 if (++PointDig==3) PointDig=0;  //rotcia digitu displeja
	ST   -Y,R17
;	Temp -> R17
	INC  R5
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x11
	CLR  R5
; 0000 00C1 Temp=Digits[PointDig];          //vber zobrazovanho digitu
_0x11:
	LDI  R26,LOW(_Digits)
	ADD  R26,R5
	LD   R17,X
; 0000 00C2 
; 0000 00C3 O_SegA=CheckBit(Temp,0);        //nastavenie segmentu A pre digit
	SBRC R17,0
	RJMP _0x12
	CBI  0x12,0
	RJMP _0x13
_0x12:
	SBI  0x12,0
_0x13:
; 0000 00C4 O_SegB=CheckBit(Temp,1);        //nastavenie segmentu B pre digit
	SBRC R17,1
	RJMP _0x14
	CBI  0x18,2
	RJMP _0x15
_0x14:
	SBI  0x18,2
_0x15:
; 0000 00C5 O_SegC=CheckBit(Temp,2);        //nastavenie segmentu C pre digit
	SBRC R17,2
	RJMP _0x16
	CBI  0x12,4
	RJMP _0x17
_0x16:
	SBI  0x12,4
_0x17:
; 0000 00C6 O_SegD=CheckBit(Temp,3);        //nastavenie segmentu D pre digit
	SBRC R17,3
	RJMP _0x18
	CBI  0x1B,0
	RJMP _0x19
_0x18:
	SBI  0x1B,0
_0x19:
; 0000 00C7 O_SegE=CheckBit(Temp,4);        //nastavenie segmentu E pre digit
	SBRC R17,4
	RJMP _0x1A
	CBI  0x1B,1
	RJMP _0x1B
_0x1A:
	SBI  0x1B,1
_0x1B:
; 0000 00C8 O_SegF=CheckBit(Temp,5);        //nastavenie segmentu F pre digit
	SBRC R17,5
	RJMP _0x1C
	CBI  0x18,4
	RJMP _0x1D
_0x1C:
	SBI  0x18,4
_0x1D:
; 0000 00C9 O_SegG=CheckBit(Temp,6);        //nastavenie segmentu G pre digit
	SBRC R17,6
	RJMP _0x1E
	CBI  0x12,5
	RJMP _0x1F
_0x1E:
	SBI  0x12,5
_0x1F:
; 0000 00CA O_SegH=CheckBit(Temp,7);        //nastavenie segmentu H pre digit
	SBRC R17,7
	RJMP _0x20
	CBI  0x12,2
	RJMP _0x21
_0x20:
	SBI  0x12,2
_0x21:
; 0000 00CB switch (PointDig)
	MOV  R30,R5
; 0000 00CC {
; 0000 00CD case 0: O_Dig1=0; break;       //zapnutie 1 digitu
	CPI  R30,0
	BRNE _0x25
	CBI  0x12,1
	RJMP _0x24
; 0000 00CE case 1: O_Dig2=0; break;       //zapnutie 2 digitu
_0x25:
	CPI  R30,LOW(0x1)
	BRNE _0x28
	CBI  0x12,3
	RJMP _0x24
; 0000 00CF case 2: O_Dig3=0; break;       //zapnutie 3 digitu
_0x28:
	CPI  R30,LOW(0x2)
	BRNE _0x24
	CBI  0x18,3
; 0000 00D0 }
_0x24:
; 0000 00D1 }
_0x2020001:
	LD   R17,Y+
	RET
; .FEND
;interrupt [12] void pin_change_isr0(void)
; 0000 00D5 {
_pin_change_isr0:
; .FSTART _pin_change_isr0
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D6 GIMSK&=0xDF;    //vypnutie preruenia od zmeny na pine PINB.0 - I_Tl;
	IN   R30,0x3B
	ANDI R30,0xDF
	OUT  0x3B,R30
; 0000 00D7 F_IdleS=0;
	CBI  0x14,4
; 0000 00D8 CountIdle=0;
	LDI  R30,LOW(0)
	STS  _CountIdle,R30
; 0000 00D9 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
; .FEND
;interrupt [14] void timer0_compa_isr(void)
; 0000 00DD {
_timer0_compa_isr:
; .FSTART _timer0_compa_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00DE char temp;
; 0000 00DF unsigned char x;
; 0000 00E0 
; 0000 00E1 TCNT0=0;        //pre sprvne nastavenie jasu displeja po prechode z Idle mdu
	RCALL __SAVELOCR2
;	temp -> R17
;	x -> R16
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00E2 if (I_Bat) OCR0B=30;
	SBIS 0x10,6
	RJMP _0x30
	LDI  R30,LOW(30)
	RJMP _0x120
; 0000 00E3 else OCR0B=60;       //doba oberstvenia displeja (2 ms) - min. 30, max. 60
_0x30:
	LDI  R30,LOW(60)
_0x120:
	OUT  0x3C,R30
; 0000 00E4 SetBit(TIFR,2);         //reset flagu OCF0B - compare
	IN   R30,0x38
	ORI  R30,4
	OUT  0x38,R30
; 0000 00E5 
; 0000 00E6 if(F_ErrorS) ModeRAM=1;         //prechod na mintky ak je chyba senzoru
	SBIS 0x13,2
	RJMP _0x32
	LDI  R30,LOW(1)
	MOV  R12,R30
; 0000 00E7 if (ModeRAM==0)
_0x32:
	TST  R12
	BRNE _0x33
; 0000 00E8 {
; 0000 00E9 if (F_Flash) SetTemperatureDisplay();         //pre zobrazenie nastavenej teploty
	SBIS 0x13,4
	RJMP _0x34
	RCALL _SetTemperatureDisplay
; 0000 00EA else TemperatureDisplay ();         //pre zobrazenie teploty
	RJMP _0x35
_0x34:
	RCALL _TemperatureDisplay
; 0000 00EB }
_0x35:
; 0000 00EC if (ModeRAM==1)
_0x33:
	LDI  R30,LOW(1)
	CP   R30,R12
	BRNE _0x36
; 0000 00ED {
; 0000 00EE if (F_Flash) TimerDisplay(ChangeNum);         //pre zobrazenie nastavenej hodnoty mintiek
	SBIS 0x13,4
	RJMP _0x37
	MOV  R26,R8
	RJMP _0x121
; 0000 00EF else
_0x37:
; 0000 00F0 {
; 0000 00F1 if (F_Timer) TimerDisplay(Timer);
	SBIS 0x13,6
	RJMP _0x39
	MOV  R26,R9
	RJMP _0x121
; 0000 00F2 else TimerDisplay(SetTimer);         //pre zobrazenie mintiek
_0x39:
	MOV  R26,R6
_0x121:
	RCALL _TimerDisplay
; 0000 00F3 }
; 0000 00F4 }
; 0000 00F5 if (ModeRAM==2)
_0x36:
	LDI  R30,LOW(2)
	CP   R30,R12
	BRNE _0x3B
; 0000 00F6 {
; 0000 00F7 if (F_Auto)     //automatika je aktvna
	SBIS 0x14,1
	RJMP _0x3C
; 0000 00F8 {
; 0000 00F9 if (!F_TempFinish) TemperatureDisplay ();         //pre zobrazenie teploty
	SBIS 0x14,2
	RCALL _TemperatureDisplay
; 0000 00FA if (F_Timer) TimerDisplay(Timer);
	SBIS 0x13,6
	RJMP _0x3E
	MOV  R26,R9
	RCALL _TimerDisplay
; 0000 00FB }
_0x3E:
; 0000 00FC else
	RJMP _0x3F
_0x3C:
; 0000 00FD {
; 0000 00FE Digits[0]=0x88;         //znak A na displej
	LDI  R30,LOW(136)
	RCALL SUBOPT_0x5
; 0000 00FF Digits[1]=0xE3;         //znak u na displej
	LDI  R30,LOW(227)
	__PUTB1MN _Digits,1
; 0000 0100 Digits[2]=0x87;         //znak t na displej
	LDI  R30,LOW(135)
	__PUTB1MN _Digits,2
; 0000 0101 }
_0x3F:
; 0000 0102 }
; 0000 0103 if (O_Heat)
_0x3B:
	SBIS 0x18,1
	RJMP _0x40
; 0000 0104 {
; 0000 0105 if (!F_Auto) ClearBit (Digits[2],7);      //indikcia ohrevu
	SBIS 0x14,1
	RJMP _0x122
; 0000 0106 else if (F_HalfS) ClearBit (Digits[2],7);
	SBIS 0x13,5
	RJMP _0x43
_0x122:
	__POINTB2MN _Digits,2
	LD   R30,X
	ANDI R30,0x7F
	ST   X,R30
; 0000 0107 }
_0x43:
; 0000 0108 else SetBit (Digits[2],7);
	RJMP _0x44
_0x40:
	__POINTB2MN _Digits,2
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
; 0000 0109 if (F_Flash)
_0x44:
	SBIS 0x13,4
	RJMP _0x45
; 0000 010A {
; 0000 010B if (F_HalfS)
	SBIS 0x13,5
	RJMP _0x46
; 0000 010C {
; 0000 010D if (!F_NoFlash) Digits[0]=0xFF, Digits[1]=0xFF, Digits[2]=0xFF;    //blikanie displeja
	SBIC 0x14,0
	RJMP _0x47
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
	LDI  R30,LOW(255)
	__PUTB1MN _Digits,2
; 0000 010E }
_0x47:
; 0000 010F }
_0x46:
; 0000 0110 RefreshDisplay();       //obersvenie displeja
_0x45:
	RCALL _RefreshDisplay
; 0000 0111 if  (!I_Tl)
	SBIC 0x16,0
	RJMP _0x48
; 0000 0112 {
; 0000 0113 CountTl++;
	INC  R13
; 0000 0114 if (CountTl==10)    //platnos tlatka 50ms
	LDI  R30,LOW(10)
	CP   R30,R13
	BRNE _0x49
; 0000 0115 {
; 0000 0116 F_Tl=1;
	SBI  0x13,0
; 0000 0117 F_Alarm=0;
	CBI  0x14,5
; 0000 0118 CountFiveSek=0;
	CLR  R2
; 0000 0119 F_FiveSek=0;
	CBI  0x13,7
; 0000 011A }
; 0000 011B if (CountTl==255) F_LongTl=1;     //platnos tl. - dlhie asy (1,275 sek)
_0x49:
	LDI  R30,LOW(255)
	CP   R30,R13
	BRNE _0x50
	SBI  0x13,1
; 0000 011C CountIdle=0;
_0x50:
	LDI  R30,LOW(0)
	STS  _CountIdle,R30
; 0000 011D }
; 0000 011E else F_Tl=0, CountTl=0;
	RJMP _0x53
_0x48:
	CBI  0x13,0
	CLR  R13
; 0000 011F 
; 0000 0120 switch(Conv_DS18B20)
_0x53:
	MOV  R30,R3
; 0000 0121 {
; 0000 0122 case 0: break;
	CPI  R30,0
	BRNE _0x59
	RJMP _0x58
; 0000 0123 case 1:
_0x59:
	CPI  R30,LOW(0x1)
	BRNE _0x5A
; 0000 0124 {
; 0000 0125 F_ErrorS=1;
	SBI  0x13,2
; 0000 0126 if(w1_init())	// trv asi 498us
	RCALL _w1_init
	CPI  R30,0
	BREQ _0x5D
; 0000 0127 {
; 0000 0128 //w1_write(DS18B20_CMD_SKIPROM);	// netaj ROM
; 0000 0129 //w1_write(DS18B20_CMD_CONVERTTEMP);	// tart konverzie
; 0000 012A F_ErrorS=0;
	CBI  0x13,2
; 0000 012B Conv_DS18B20=2;
	LDI  R30,LOW(2)
	MOV  R3,R30
; 0000 012C }
; 0000 012D }	break;
_0x5D:
	RJMP _0x58
; 0000 012E case 2:
_0x5A:
	CPI  R30,LOW(0x2)
	BRNE _0x60
; 0000 012F {
; 0000 0130 w1_write(DS18B20_CMD_SKIPROM);	// netaj ROM
	LDI  R26,LOW(204)
	RCALL _w1_write
; 0000 0131 //w1_write(DS18B20_CMD_CONVERTTEMP);	// tart konverzie
; 0000 0132 Conv_DS18B20=3;
	LDI  R30,LOW(3)
	RJMP _0x123
; 0000 0133 }	break;
; 0000 0134 case 3:
_0x60:
	CPI  R30,LOW(0x3)
	BRNE _0x61
; 0000 0135 {
; 0000 0136 w1_write(DS18B20_CMD_CONVERTTEMP);	// tart konverzie
	LDI  R26,LOW(68)
	RCALL _w1_write
; 0000 0137 Conv_DS18B20=4;
	LDI  R30,LOW(4)
	RJMP _0x123
; 0000 0138 }	break;
; 0000 0139 case 4:
_0x61:
	CPI  R30,LOW(0x4)
	BRNE _0x62
; 0000 013A {
; 0000 013B if(w1_init())	// trv asi 498us
	RCALL _w1_init
	CPI  R30,0
	BREQ _0x63
; 0000 013C {
; 0000 013D //w1_write(DS18B20_CMD_SKIPROM);	// netaj ROM
; 0000 013E //w1_write(DS18B20_CMD_RSCRATCHPAD);	// tart konverzie
; 0000 013F F_ErrorS=0;
	CBI  0x13,2
; 0000 0140 Conv_DS18B20=5;
	LDI  R30,LOW(5)
	RJMP _0x124
; 0000 0141 }
; 0000 0142 else Conv_DS18B20=1;
_0x63:
	LDI  R30,LOW(1)
_0x124:
	MOV  R3,R30
; 0000 0143 }	break;
	RJMP _0x58
; 0000 0144 case 5:
_0x62:
	CPI  R30,LOW(0x5)
	BRNE _0x67
; 0000 0145 {
; 0000 0146 w1_write(DS18B20_CMD_SKIPROM);	// netaj ROM
	LDI  R26,LOW(204)
	RCALL _w1_write
; 0000 0147 //w1_write(DS18B20_CMD_RSCRATCHPAD);	// tart konverzie
; 0000 0148 Conv_DS18B20=6;
	LDI  R30,LOW(6)
	RJMP _0x123
; 0000 0149 }	break;
; 0000 014A case 6:
_0x67:
	CPI  R30,LOW(0x6)
	BRNE _0x68
; 0000 014B {
; 0000 014C w1_write(DS18B20_CMD_RSCRATCHPAD);	// tart konverzie
	LDI  R26,LOW(190)
	RCALL _w1_write
; 0000 014D Conv_DS18B20=7;
	LDI  R30,LOW(7)
	RJMP _0x123
; 0000 014E }	break;
; 0000 014F case 7:
_0x68:
	CPI  R30,LOW(0x7)
	BRNE _0x69
; 0000 0150 {
; 0000 0151 // pretanie 2 bytov teploty
; 0000 0152 temperature_l=w1_read();
	RCALL _w1_read
	STS  _temperature_l,R30
; 0000 0153 Conv_DS18B20=8;
	LDI  R30,LOW(8)
	RJMP _0x123
; 0000 0154 
; 0000 0155 }	break;
; 0000 0156 case 8:
_0x69:
	CPI  R30,LOW(0x8)
	BRNE _0x6A
; 0000 0157 {
; 0000 0158 // pretanie 2 bytov teploty
; 0000 0159 temperature_h=w1_read();
	RCALL _w1_read
	STS  _temperature_h,R30
; 0000 015A Conv_DS18B20=9;
	LDI  R30,LOW(9)
	RJMP _0x123
; 0000 015B }	break;
; 0000 015C case 9:
_0x6A:
	CPI  R30,LOW(0x9)
	BRNE _0x58
; 0000 015D {
; 0000 015E temp=0x0F&temperature_l;	// pre sprvne zobraznie teploty v mnusovch hodnotch
	LDS  R30,_temperature_l
	ANDI R30,LOW(0xF)
	MOV  R17,R30
; 0000 015F if(temp==0) x=1;
	CPI  R17,0
	BRNE _0x6C
	LDI  R16,LOW(1)
; 0000 0160 temp=( temperature_h << 4 ) | (temperature_l >> 4);		// teplota iba z 8 bitov DS18B20
_0x6C:
	LDS  R30,_temperature_h
	SWAP R30
	ANDI R30,0xF0
	MOV  R26,R30
	LDS  R30,_temperature_l
	SWAP R30
	ANDI R30,0xF
	OR   R30,R26
	MOV  R17,R30
; 0000 0161 if(temp<0)
	CPI  R17,0
	BRGE _0x6D
; 0000 0162 {
; 0000 0163 F_NegTemp=1;
	SBI  0x13,3
; 0000 0164 temp=~temp;
	COM  R17
; 0000 0165 temp+=x;
	ADD  R17,R16
; 0000 0166 }
; 0000 0167 else F_NegTemp=0;
	RJMP _0x70
_0x6D:
	CBI  0x13,3
; 0000 0168 Teplota=temp;
_0x70:
	MOV  R4,R17
; 0000 0169 Conv_DS18B20=1;
	LDI  R30,LOW(1)
_0x123:
	MOV  R3,R30
; 0000 016A }	break;
; 0000 016B }
_0x58:
; 0000 016C 
; 0000 016D while (!CheckBit(TIFR,2));     //akaj na dokonenie doby (2 ms)
_0x73:
	IN   R30,0x38
	ANDI R30,LOW(0x4)
	BREQ _0x73
; 0000 016E O_Dig1=1, O_Dig2=1, O_Dig3=1;   //zhasnutie displeja
	SBI  0x12,1
	SBI  0x12,3
	SBI  0x18,3
; 0000 016F }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;interrupt [5] void timer1_compa_isr(void)
; 0000 0185 {
_timer1_compa_isr:
; .FSTART _timer1_compa_isr
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0186 #asm ("wdr")            //watchdog reset
	WDR
; 0000 0187 
; 0000 0188 F_HalfS=~F_HalfS;       //vytvorenie pol sekundovch pulzov
	SBIS 0x13,5
	RJMP _0x7C
	CBI  0x13,5
	RJMP _0x7D
_0x7C:
	SBI  0x13,5
_0x7D:
; 0000 0189 
; 0000 018A if (Teplota<SetTemp-1) O_Heat=1;
	MOV  R30,R7
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x7E
	SBI  0x18,1
; 0000 018B if (Teplota>=SetTemp) O_Heat=0;
_0x7E:
	CP   R4,R7
	BRLO _0x81
	CBI  0x18,1
; 0000 018C if (F_NegTemp) O_Heat=1;        //ak je zporn teplota - ohrev
_0x81:
	SBIC 0x13,3
	SBI  0x18,1
; 0000 018D if (F_ErrorS) O_Heat=0;
	SBIC 0x13,2
	CBI  0x18,1
; 0000 018E if (++CountFiveSek==10) F_FiveSek=1;
	INC  R2
	LDI  R30,LOW(10)
	CP   R30,R2
	BRNE _0x8A
	SBI  0x13,7
; 0000 018F if (F_Idle)
_0x8A:
	SBIS 0x14,3
	RJMP _0x8D
; 0000 0190 {
; 0000 0191 if (++CountIdle==20) F_IdleS=1;        //odtavanie asu do prechodu na Idle md
	LDS  R26,_CountIdle
	SUBI R26,-LOW(1)
	STS  _CountIdle,R26
	CPI  R26,LOW(0x14)
	BRNE _0x8E
	SBI  0x14,4
; 0000 0192 }
_0x8E:
; 0000 0193 if (F_Timer)    //zobrazenie znaku beiacich mintiek
_0x8D:
	SBIS 0x13,6
	RJMP _0x91
; 0000 0194 {
; 0000 0195 if (++RunTimer==4) RunTimer=0;
	INC  R11
	LDI  R30,LOW(4)
	CP   R30,R11
	BRNE _0x92
	CLR  R11
; 0000 0196 if (++CountTimMin==120)
_0x92:
	INC  R10
	LDI  R30,LOW(120)
	CP   R30,R10
	BRNE _0x93
; 0000 0197 {
; 0000 0198 CountTimMin=0;
	CLR  R10
; 0000 0199 if (--Timer==0) F_Timer=0, F_Alarm=1;
	DEC  R9
	BRNE _0x94
	CBI  0x13,6
	SBI  0x14,5
; 0000 019A }
_0x94:
; 0000 019B }
_0x93:
; 0000 019C else CountTimMin=0;
	RJMP _0x99
_0x91:
	CLR  R10
; 0000 019D if (F_Auto)
_0x99:
	SBIS 0x14,1
	RJMP _0x9A
; 0000 019E {
; 0000 019F if (F_TempFinish)
	SBIS 0x14,2
	RJMP _0x9B
; 0000 01A0 {
; 0000 01A1 if (!F_Timer) F_Auto=0, F_TempFinish=0, F_Alarm=1; //ukonenie automatiky
	SBIC 0x13,6
	RJMP _0x9C
	CBI  0x14,1
	CBI  0x14,2
	SBI  0x14,5
; 0000 01A2 }
_0x9C:
; 0000 01A3 else
	RJMP _0xA3
_0x9B:
; 0000 01A4 {
; 0000 01A5 if (!O_Heat) F_TempFinish=1, F_Timer=1, F_Alarm=1;
	SBIC 0x18,1
	RJMP _0xA4
	SBI  0x14,2
	SBI  0x13,6
	SBI  0x14,5
; 0000 01A6 }
_0xA4:
_0xA3:
; 0000 01A7 }
; 0000 01A8 if (F_Alarm) O_Horn=F_HalfS;  //zvukov signalizcia0
_0x9A:
	SBIS 0x14,5
	RJMP _0xAB
	SBIC 0x13,5
	RJMP _0xAC
	CBI  0x18,5
	RJMP _0xAD
_0xAC:
	SBI  0x18,5
_0xAD:
; 0000 01A9 else O_Horn=1;
	RJMP _0xAE
_0xAB:
	SBI  0x18,5
; 0000 01AA 
; 0000 01AB if (F_Signal)
_0xAE:
	SBIS 0x14,6
	RJMP _0xB1
; 0000 01AC {
; 0000 01AD if(!F_Aux_M) O_Horn=0, F_Aux_M=1;     //zvukov signalizcia - 0,5 sek
	SBIC 0x14,7
	RJMP _0xB2
	CBI  0x18,5
	SBI  0x14,7
; 0000 01AE }
_0xB2:
; 0000 01AF else F_Aux_M=0;
	RJMP _0xB7
_0xB1:
	CBI  0x14,7
; 0000 01B0 }
_0xB7:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND
;void Mode2(void)
; 0000 01B4 {
_Mode2:
; .FSTART _Mode2
; 0000 01B5 F_Flash=0;
	CBI  0x13,4
; 0000 01B6 if (!F_Auto)
	SBIC 0x14,1
	RJMP _0xBC
; 0000 01B7 {
; 0000 01B8 if (F_LongTl) F_Auto=1, Timer=SetTimer;    //pri dlhom stlaen - tart automatiky
	SBIS 0x13,1
	RJMP _0xBD
	SBI  0x14,1
	MOV  R9,R6
; 0000 01B9 else ModeRAM=0;
	RJMP _0xC0
_0xBD:
	CLR  R12
; 0000 01BA }
_0xC0:
; 0000 01BB else
	RJMP _0xC1
_0xBC:
; 0000 01BC {
; 0000 01BD if (F_LongTl) F_Auto=0, F_TempFinish=0, F_Timer=0;    //pri dlhom staen -  koniec automatiky
	SBIS 0x13,1
	RJMP _0xC2
	CBI  0x14,1
	CBI  0x14,2
	CBI  0x13,6
; 0000 01BE }
_0xC2:
_0xC1:
; 0000 01BF }
	RET
; .FEND
;unsigned char Changes (void)
; 0000 01C3 {
_Changes:
; .FSTART _Changes
; 0000 01C4 while (F_Tl);   //wait realese Tl
_0xC9:
	SBIC 0x13,0
	RJMP _0xC9
; 0000 01C5 if (!F_LongTl)
	SBIC 0x13,1
	RJMP _0xCC
; 0000 01C6 {
; 0000 01C7 if (ModeRAM==0) ModeRAM=1;      //tlatko stlaen krtko < 2 sekundy - Prechod na Mintky Mod 1
	TST  R12
	BRNE _0xCD
	LDI  R30,LOW(1)
	RJMP _0x125
; 0000 01C8 else ModeRAM=2;
_0xCD:
	LDI  R30,LOW(2)
_0x125:
	MOV  R12,R30
; 0000 01C9 }
; 0000 01CA else
	RJMP _0xCF
_0xCC:
; 0000 01CB {
; 0000 01CC while (1)
_0xD0:
; 0000 01CD {
; 0000 01CE if (F_Tl)
	SBIS 0x13,0
	RJMP _0xD3
; 0000 01CF {
; 0000 01D0 ChangeNum++;
	INC  R8
; 0000 01D1 if (ChangeNum>99) ChangeNum=1;
	LDI  R30,LOW(99)
	CP   R30,R8
	BRSH _0xD4
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 01D2 CountTl=0;
_0xD4:
	CLR  R13
; 0000 01D3 while (F_Tl)  //wait realese Tl
_0xD5:
	SBIS 0x13,0
	RJMP _0xD7
; 0000 01D4 {
; 0000 01D5 F_NoFlash=1;
	SBI  0x14,0
; 0000 01D6 if (CountTl==25)        //30 pvodne
	LDI  R30,LOW(25)
	CP   R30,R13
	BRNE _0xDA
; 0000 01D7 {
; 0000 01D8 ChangeNum++;
	INC  R8
; 0000 01D9 if (ChangeNum>99) ChangeNum=1;
	LDI  R30,LOW(99)
	CP   R30,R8
	BRSH _0xDB
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 01DA CountTl=0;
_0xDB:
	CLR  R13
; 0000 01DB }
; 0000 01DC }
_0xDA:
	RJMP _0xD5
_0xD7:
; 0000 01DD F_NoFlash=0;
	CBI  0x14,0
; 0000 01DE }
; 0000 01DF if (F_FiveSek)
_0xD3:
	SBIS 0x13,7
	RJMP _0xDE
; 0000 01E0 {
; 0000 01E1 if (ModeRAM==1) F_Timer=1, CountTimMin=0, Timer=ChangeNum;        //tart mintiek
	LDI  R30,LOW(1)
	CP   R30,R12
	BRNE _0xDF
	SBI  0x13,6
	CLR  R10
	MOV  R9,R8
; 0000 01E2 break;
_0xDF:
	RJMP _0xD2
; 0000 01E3 }
; 0000 01E4 }
_0xDE:
	RJMP _0xD0
_0xD2:
; 0000 01E5 }
_0xCF:
; 0000 01E6 F_Flash=0;        //blikanie displeja ukonen
	CBI  0x13,4
; 0000 01E7 //while (F_Tl);  //wait realese Tl
; 0000 01E8 return ChangeNum;
	MOV  R30,R8
	RET
; 0000 01E9 }
; .FEND
;void Mode1 (void)
; 0000 01ED {
_Mode1:
; .FSTART _Mode1
; 0000 01EE if (F_Timer)
	SBIS 0x13,6
	RJMP _0xE4
; 0000 01EF {
; 0000 01F0 if (F_LongTl) F_Timer=0, F_Flash=0;    //pri dlhom stlaen - koniec
	SBIS 0x13,1
	RJMP _0xE5
	CBI  0x13,6
	CBI  0x13,4
; 0000 01F1 else ModeRAM=0;
	RJMP _0xEA
_0xE5:
	CLR  R12
; 0000 01F2 }
_0xEA:
; 0000 01F3 else
	RJMP _0xEB
_0xE4:
; 0000 01F4 {
; 0000 01F5 ChangeNum=SetTimer;
	MOV  R8,R6
; 0000 01F6 SetTimer=Changes();
	RCALL _Changes
	MOV  R6,R30
; 0000 01F7 SetTimerEE=SetTimer;
	LDI  R26,LOW(_SetTimerEE)
	LDI  R27,HIGH(_SetTimerEE)
	RCALL __EEPROMWRB
; 0000 01F8 }
_0xEB:
; 0000 01F9 }
	RET
; .FEND
;void Mode0(void)
; 0000 01FD {
_Mode0:
; .FSTART _Mode0
; 0000 01FE if (!F_ErrorS)
	SBIC 0x13,2
	RJMP _0xEC
; 0000 01FF {
; 0000 0200 ChangeNum=SetTemp;
	MOV  R8,R7
; 0000 0201 SetTemp=Changes();
	RCALL _Changes
	MOV  R7,R30
; 0000 0202 SetTempEE=SetTemp;
	RCALL SUBOPT_0x7
	RCALL __EEPROMWRB
; 0000 0203 }
; 0000 0204 else
	RJMP _0xED
_0xEC:
; 0000 0205 {
; 0000 0206 ModeRAM=1;      //prechod na minutky
	LDI  R30,LOW(1)
	MOV  R12,R30
; 0000 0207 }
_0xED:
; 0000 0208 }
	RET
; .FEND
;void main(void)
; 0000 020B {
_main:
; .FSTART _main
; 0000 020C // Crystal Oscillator division factor: 1
; 0000 020D #pragma optsize-
; 0000 020E CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 020F CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0210 #ifdef _OPTIMIZE_SIZE_
; 0000 0211 #pragma optsize+
; 0000 0212 #endif
; 0000 0213 
; 0000 0214 // Input/Output Ports initialization
; 0000 0215 // Port A initialization
; 0000 0216 // Func2=In Func1=Out Func0=Out
; 0000 0217 // State2=T State1=1 State0=1
; 0000 0218 PORTA=0x03;
	LDI  R30,LOW(3)
	OUT  0x1B,R30
; 0000 0219 DDRA=0x03;
	OUT  0x1A,R30
; 0000 021A 
; 0000 021B // Port B initialization
; 0000 021C // Func7=Out Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0000 021D // State7=1 State6=P State5=1 State4=1 State3=1 State2=1 State1=0 State0=P
; 0000 021E PORTB=0xFD;
	LDI  R30,LOW(253)
	OUT  0x18,R30
; 0000 021F DDRB=0xBE;
	LDI  R30,LOW(190)
	OUT  0x17,R30
; 0000 0220 
; 0000 0221 // Port D initialization
; 0000 0222 // Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0223 // State6=P State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 0224 PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
; 0000 0225 DDRD=0x3F;
	LDI  R30,LOW(63)
	OUT  0x11,R30
; 0000 0226 
; 0000 0227 // Timer/Counter 0 initialization
; 0000 0228 // Clock source: System Clock
; 0000 0229 // Clock value: 15,625 kHz
; 0000 022A // Mode: CTC
; 0000 022B // OC0A output: Disconnected
; 0000 022C // OC0B output: Disconnected
; 0000 022D TCCR0A=0x02;
	LDI  R30,LOW(2)
	OUT  0x30,R30
; 0000 022E TCCR0B=0x04;
	LDI  R30,LOW(4)
	OUT  0x33,R30
; 0000 022F //TCNT0=0x00;
; 0000 0230 OCR0A=0x4E;
	LDI  R30,LOW(78)
	OUT  0x36,R30
; 0000 0231 //OCR0B=0x00;
; 0000 0232 
; 0000 0233 // Timer/Counter 1 initialization
; 0000 0234 // Clock source: System Clock
; 0000 0235 // Clock value: 62,500 kHz
; 0000 0236 // Mode: CTC
; 0000 0237 // OC1A output: Discon.
; 0000 0238 // OC1B output: Discon.
; 0000 0239 // Noise Canceler: Off
; 0000 023A // Input Capture on Falling Edge
; 0000 023B // Timer 1 Overflow Interrupt: Off
; 0000 023C // Input Capture Interrupt: Off
; 0000 023D // Compare A Match Interrupt: On
; 0000 023E // Compare B Match Interrupt: Off
; 0000 023F //TCCR1A=0x00;
; 0000 0240 TCCR1B=0x0B;
	LDI  R30,LOW(11)
	OUT  0x2E,R30
; 0000 0241 //TCNT1H=0x00;
; 0000 0242 //TCNT1L=0x00;
; 0000 0243 //ICR1H=0x00;
; 0000 0244 //ICR1L=0x00;
; 0000 0245 //OCR1AH=0x7A;
; 0000 0246 //OCR1AL=0x12;
; 0000 0247 //OCR1BH=0x00;
; 0000 0248 //OCR1BL=0x00;
; 0000 0249 OCR1A=39321;    //mus by prepotan - men sa deliaci pomer pri meran teploty na /1 (39287)
	LDI  R30,LOW(39321)
	LDI  R31,HIGH(39321)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 024A OCR1B=8200;       //doba potrebn pre informcie zo senzoru teploty do - 2,05 ms
	LDI  R30,LOW(8200)
	LDI  R31,HIGH(8200)
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 024B 
; 0000 024C // External Interrupt(s) initialization
; 0000 024D // INT0: Off
; 0000 024E // INT1: Off
; 0000 024F // Interrupt on any change on pins PCINT0-7: On
; 0000 0250 //GIMSK=0x00;     //preruenie disable - (enable: GIMSK=0x20)
; 0000 0251 MCUCR=0x20;     //povolenia sleep modu
	LDI  R30,LOW(32)
	OUT  0x35,R30
; 0000 0252 PCMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x20,R30
; 0000 0253 //EIFR=0x20;
; 0000 0254 
; 0000 0255 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0256 TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 0257 
; 0000 0258 // Universal Serial Interface initialization
; 0000 0259 // Mode: Disabled
; 0000 025A // Clock source: Register & Counter=no clk.
; 0000 025B // USI Counter Overflow Interrupt: Off
; 0000 025C //USICR=0x00;
; 0000 025D 
; 0000 025E // Analog Comparator initialization
; 0000 025F // Analog Comparator: Off
; 0000 0260 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0261 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0262 
; 0000 0263 // Watchdog Timer initialization
; 0000 0264 // Watchdog Timer Prescaler: OSC/256k
; 0000 0265 // Watchdog Timer interrupt: Off
; 0000 0266 #pragma optsize-
; 0000 0267 WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 0268 WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 0269 #ifdef _OPTIMIZE_SIZE_
; 0000 026A #pragma optsize+
; 0000 026B #endif
; 0000 026C 
; 0000 026D /*zpis kalibranho sla pre intern osciltor - od vrobcu sa po resete zapisuje automaticky
; 0000 026E do OSCCAL ale laden pre 3V a 25C - pre V je nutn odta 5.*/
; 0000 026F OSCCAL=OSCCAL-5;
	IN   R30,0x31
	SUBI R30,LOW(5)
	OUT  0x31,R30
; 0000 0270 /*if (ModeEE==0xFF) ModeEE=0;     //pri prvom zapnut navolenie mdu 0 - regulcia teploty
; 0000 0271 ModeRAM=ModeEE;         //prepis zvolenho mdu do RAM pamte*/
; 0000 0272 if (SetTempEE==0xFF) SetTempEE=20, SetTimerEE=15;      //vchodzia nastaven teplota 20C + vchodzia hodnota mintiek
	RCALL SUBOPT_0x7
	RCALL __EEPROMRDB
	CPI  R30,LOW(0xFF)
	BRNE _0xEE
	RCALL SUBOPT_0x7
	LDI  R30,LOW(20)
	RCALL __EEPROMWRB
	LDI  R26,LOW(_SetTimerEE)
	LDI  R27,HIGH(_SetTimerEE)
	LDI  R30,LOW(15)
	RCALL __EEPROMWRB
; 0000 0273 SetTemp=SetTempEE;
_0xEE:
	RCALL SUBOPT_0x7
	RCALL __EEPROMRDB
	MOV  R7,R30
; 0000 0274 SetTimer=SetTimerEE;
	LDI  R26,LOW(_SetTimerEE)
	LDI  R27,HIGH(_SetTimerEE)
	RCALL __EEPROMRDB
	MOV  R6,R30
; 0000 0275 
; 0000 0276 // Global enable interrupts
; 0000 0277 #asm("sei")
	SEI
; 0000 0278 while (!I_Tl)   //tl. zopnut
_0xEF:
	SBIC 0x16,0
	RJMP _0xF1
; 0000 0279 {
; 0000 027A if (F_LongTl) F_Idle=1, F_Signal=1;
	SBIS 0x13,1
	RJMP _0xF2
	SBI  0x14,3
	SBI  0x14,6
; 0000 027B }
_0xF2:
	RJMP _0xEF
_0xF1:
; 0000 027C while (F_Tl);
_0xF7:
	SBIC 0x13,0
	RJMP _0xF7
; 0000 027D F_Signal=0;
	CBI  0x14,6
; 0000 027E 
; 0000 027F while (1)
_0xFC:
; 0000 0280 {
; 0000 0281 if(F_Alarm)    //ke je alarm - vyradi tlatko
	SBIS 0x14,5
	RJMP _0xFF
; 0000 0282 {
; 0000 0283 while(F_Alarm);
_0x100:
	SBIC 0x14,5
	RJMP _0x100
; 0000 0284 while(F_Tl);
_0x103:
	SBIC 0x13,0
	RJMP _0x103
; 0000 0285 }
; 0000 0286 if (F_Tl)
_0xFF:
	SBIS 0x13,0
	RJMP _0x106
; 0000 0287 {
; 0000 0288 F_LongTl=0;
	CBI  0x13,1
; 0000 0289 while (F_Tl)      //wait realese Tl
_0x109:
	SBIS 0x13,0
	RJMP _0x10B
; 0000 028A {
; 0000 028B if (F_LongTl)        //tlatko stlaen dlho > 1,5 sekundy + blikanie displeja
	SBIS 0x13,1
	RJMP _0x10C
; 0000 028C {
; 0000 028D F_Flash=1;
	SBI  0x13,4
; 0000 028E break;
	RJMP _0x10B
; 0000 028F }
; 0000 0290 }
_0x10C:
	RJMP _0x109
_0x10B:
; 0000 0291 switch (ModeRAM)
	MOV  R30,R12
; 0000 0292 {
; 0000 0293 case 0: Mode0(); break;        //prechod na md 0 = Regulcia teploty
	CPI  R30,0
	BRNE _0x112
	RCALL _Mode0
	RJMP _0x111
; 0000 0294 case 1: Mode1(); break;       //prechod na md 1 = Mintky
_0x112:
	CPI  R30,LOW(0x1)
	BRNE _0x113
	RCALL _Mode1
	RJMP _0x111
; 0000 0295 case 2: Mode2(); break;         //prechod ba md 2 = Automatika pre zavranie
_0x113:
	CPI  R30,LOW(0x2)
	BRNE _0x111
	RCALL _Mode2
; 0000 0296 }
_0x111:
; 0000 0297 while (F_Tl);   //wait realese Tl
_0x115:
	SBIC 0x13,0
	RJMP _0x115
; 0000 0298 }
; 0000 0299 if (F_IdleS)
_0x106:
	SBIS 0x14,4
	RJMP _0x118
; 0000 029A {
; 0000 029B while (F_IdleS)
_0x119:
	SBIS 0x14,4
	RJMP _0x11B
; 0000 029C {
; 0000 029D EIFR=0x20;      //reset flagu preruenia PIN Change
	LDI  R30,LOW(32)
	OUT  0x3A,R30
; 0000 029E TIMSK&=0xFE;    //vypnutie preruenia od Timer0
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
; 0000 029F GIMSK|=0x20;    //zapnutie preruenia od zmeny na pine PINB.0 - I_Tl;
	IN   R30,0x3B
	ORI  R30,0x20
	OUT  0x3B,R30
; 0000 02A0 #asm ("sleep")  //prechod do Idle mdu
	sleep
; 0000 02A1 }
	RJMP _0x119
_0x11B:
; 0000 02A2 while (!I_Tl);  //akaj na pustenie tl.
_0x11C:
	SBIS 0x16,0
	RJMP _0x11C
; 0000 02A3 TIMSK|=0x01;    //zapnutie preruenia od Timer0
	IN   R30,0x39
	ORI  R30,1
	OUT  0x39,R30
; 0000 02A4 }
; 0000 02A5 };
_0x118:
	RJMP _0xFC
; 0000 02A6 }
_0x11F:
	RJMP _0x11F
; .FEND

	.CSEG
_bin2bcd:
; .FSTART _bin2bcd
	ST   -Y,R26
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret
; .FEND

	.DSEG
_Digits:
	.BYTE 0x3
_CountIdle:
	.BYTE 0x1
_temperature_l:
	.BYTE 0x1
_temperature_h:
	.BYTE 0x1

	.ESEG
_SetTempEE:
	.BYTE 0x1
_SetTimerEE:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(_TableChar*2)
	LDI  R31,HIGH(_TableChar*2)
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(255)
	STS  _Digits,R30
	__GETB2MN _Digits,1
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(255)
	__PUTB1MN _Digits,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LPM  R0,Z
	STS  _Digits,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x4:
	MOV  R17,R30
	SWAP R30
	ANDI R30,0xF
	LDI  R31,0
	SUBI R30,LOW(-_TableChar*2)
	SBCI R31,HIGH(-_TableChar*2)
	LPM  R0,Z
	__PUTBR0MN _Digits,1
	MOV  R30,R17
	ANDI R30,LOW(0xF)
	LDI  R31,0
	SUBI R30,LOW(-_TableChar*2)
	SBCI R31,HIGH(-_TableChar*2)
	LPM  R0,Z
	__PUTBR0MN _Digits,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	STS  _Digits,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	LDI  R31,0
	SUBI R30,LOW(-_TableChar*2)
	SBCI R31,HIGH(-_TableChar*2)
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(_SetTempEE)
	LDI  R27,HIGH(_SetTempEE)
	RET

;RUNTIME LIBRARY

	.CSEG
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

	.equ __w1_port=0x18
	.equ __w1_dir=0x17
	.equ __w1_inp=0x16
	.equ __w1_bit=0x06

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_dir,__w1_bit
	__DELAY_USW 0x1E0
	cbi  __w1_dir,__w1_bit
	__DELAY_USB 0x13
	sbis __w1_inp,__w1_bit
	ret
	__DELAY_USB 0x65
	sbis __w1_inp,__w1_bit
	ldi  r30,1
	__DELAY_USW 0x186
	ret

__w1_read_bit:
	sbi  __w1_dir,__w1_bit
	__DELAY_USB 0x3
	cbi  __w1_dir,__w1_bit
	__DELAY_USB 0xF
	clc
	sbic __w1_inp,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0x6B
	ret

__w1_write_bit:
	clt
	sbi  __w1_dir,__w1_bit
	__DELAY_USB 0x3
	sbrc r23,0
	cbi  __w1_dir,__w1_bit
	__DELAY_USB 0x11
	sbic __w1_inp,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0x64
	cbi  __w1_dir,__w1_bit
	__DELAY_USB 0x7
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	mov  r23,r26
	ldi  r22,8
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
