
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+
unsigned char bcd2bin(unsigned char n);
unsigned char bin2bcd(unsigned char n);
#pragma used-
#pragma library bcd.lib

#pragma used+
unsigned char w1_init(void);
unsigned char w1_read(void);
unsigned char w1_write(unsigned char data);
unsigned char w1_search(unsigned char cmd,void *p);
unsigned char w1_dow_crc8(void *p,unsigned char n);
#pragma used-
#pragma used+
void delay_us(unsigned int n);
void delay_ms(unsigned int n);
#pragma used-
flash unsigned char TableChar[10]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90};
flash unsigned char TableTimer[4]={0xBF,0xFB,0xF7,0xEF};      
bit F_Tl;               
bit F_LongTl;           
bit F_ErrorS;           
bit F_NegTemp;          
bit F_Flash;            
bit F_HalfS;            
bit F_Timer;            
bit F_FiveSek;          
bit F_NoFlash;          
bit F_Auto;             
bit F_TempFinish;       
bit F_Idle;              
bit F_IdleS;            
bit F_Alarm;
bit F_Signal;           
bit F_Aux_M;            
unsigned char Conv_DS18B20=1;         
unsigned char CountFiveSek;  
unsigned char PointDig; 
unsigned char Digits[3];     
unsigned char Teplota;  
unsigned char SetTemp;        
unsigned char SetTimer;         
unsigned char Timer;            
unsigned char ChangeNum;                   
unsigned char RunTimer;         
unsigned char CountTimMin;      
unsigned char CountTl;       
unsigned char ModeRAM;
unsigned char CountIdle;        
unsigned char temperature_l;
unsigned char temperature_h;
eeprom char SetTempEE;  
eeprom char SetTimerEE; 
void ElZero(void)
{
if (Digits[0]==TableChar[0])    
{
Digits[0]=0xFF;
if (Digits[1]==TableChar[0]) Digits[1]=0xFF;
}
}
void TemperatureDisplay (void)
{
unsigned char Temp;     
if (Teplota>=200) Temp=Teplota-200, Digits[0]=TableChar[2];     
else if (Teplota>=100) Temp=Teplota-100, Digits[0]=TableChar[1];
else Digits[0]=TableChar[0], Temp=Teplota;
Temp=bin2bcd(Temp);  
Digits[1]=TableChar[Temp>>4];   
Digits[2]=TableChar[Temp&0x0F]; 
ElZero();       
if (F_NegTemp)                               
{
if (Digits[1]==0xFF) Digits[1]=0xBF      ;
else Digits[0]=0xBF      ;
}
}
void SetTemperatureDisplay(void)
{
unsigned char Temp;     
Temp=bin2bcd(ChangeNum);  
Digits[0]=TableChar[0];         
Digits[1]=TableChar[Temp>>4];   
Digits[2]=TableChar[Temp&0x0F]; 
ElZero();       
if (Digits[0]==TableChar[0])    
{
Digits[0]=0xFF;
if (Digits[1]==TableChar[0]) Digits[1]=0xFF;
}
}
void TimerDisplay(unsigned char Num)
{
unsigned char Temp;     
Temp=bin2bcd(Num);  
Digits[1]=TableChar[Temp>>4];   
Digits[2]=TableChar[Temp&0x0F]; 
if (Digits[1]==TableChar[0]) Digits[1]=0xFF;  
if (F_Timer)
{
Digits[0]=TableTimer[RunTimer];
}
else Digits[0]=0xA3;    ;         
}
void RefreshDisplay (void)
{
unsigned char Temp;
if (++PointDig==3) PointDig=0;  
Temp=Digits[PointDig];          
PORTD.0    =(Temp&(1<<0))          ;        
PORTB.2    =(Temp&(1<<1))          ;        
PORTD.4    =(Temp&(1<<2))          ;        
PORTA.0    =(Temp&(1<<3))          ;        
PORTA.1    =(Temp&(1<<4))          ;        
PORTB.4    =(Temp&(1<<5))          ;        
PORTD.5    =(Temp&(1<<6))          ;        
PORTD.2    =(Temp&(1<<7))          ;        
switch (PointDig)
{
case 0: PORTD.1    =0; break;       
case 1: PORTD.3    =0; break;       
case 2: PORTB.3    =0; break;       
}
}
interrupt [12] void pin_change_isr0(void)
{
GIMSK&=0xDF;    
F_IdleS=0;
CountIdle=0;
}
interrupt [14] void timer0_compa_isr(void)
{
char temp;
unsigned char x;
TCNT0=0;        
if (PIND.6    ) OCR0B=30;
else OCR0B=60;       
(TIFR|=(1<<2))           ;         
if(F_ErrorS) ModeRAM=1;         
if (ModeRAM==0)
{
if (F_Flash) SetTemperatureDisplay();         
else TemperatureDisplay ();         
}
if (ModeRAM==1)
{
if (F_Flash) TimerDisplay(ChangeNum);         
else
{
if (F_Timer) TimerDisplay(Timer);
else TimerDisplay(SetTimer);         
}
}
if (ModeRAM==2)
{
if (F_Auto)     
{
if (!F_TempFinish) TemperatureDisplay ();         
if (F_Timer) TimerDisplay(Timer);
}
else
{
Digits[0]=0x88;         
Digits[1]=0xE3;         
Digits[2]=0x87;         
}
}
if (PORTB.1    )
{
if (!F_Auto) (Digits[2]&=~(1<<7))         ;      
else if (F_HalfS) (Digits[2]&=~(1<<7))         ;
}
else (Digits[2]|=(1<<7))           ;
if (F_Flash)
{
if (F_HalfS)
{
if (!F_NoFlash) Digits[0]=0xFF, Digits[1]=0xFF, Digits[2]=0xFF;    
}
}
RefreshDisplay();       
if  (!PINB.0    )
{
CountTl++;
if (CountTl==10)    
{
F_Tl=1;
F_Alarm=0;
CountFiveSek=0;
F_FiveSek=0;
}
if (CountTl==255) F_LongTl=1;     
CountIdle=0;
}
else F_Tl=0, CountTl=0;
switch(Conv_DS18B20)
{
case 0: break;
case 1:
{
F_ErrorS=1;
if(w1_init())	
{
F_ErrorS=0;
Conv_DS18B20=2;
}
}	break;
case 2:
{
w1_write(0xcc);	
Conv_DS18B20=3;
}	break;
case 3:
{
w1_write(0x44);	
Conv_DS18B20=4;
}	break;
case 4:
{
if(w1_init())	
{
F_ErrorS=0;
Conv_DS18B20=5;
}
else Conv_DS18B20=1;
}	break;
case 5:
{
w1_write(0xcc);	
Conv_DS18B20=6;
}	break;
case 6:
{
w1_write(0xbe);	
Conv_DS18B20=7;
}	break;
case 7:
{
temperature_l=w1_read();
Conv_DS18B20=8;
}	break;
case 8:
{
temperature_h=w1_read();
Conv_DS18B20=9;
}	break;
case 9:
{
temp=0x0F&temperature_l;	
if(temp==0) x=1;
temp=( temperature_h << 4 ) | (temperature_l >> 4);		
if(temp<0)
{
F_NegTemp=1;
temp=~temp;
temp+=x;
}
else F_NegTemp=0;
Teplota=temp;
Conv_DS18B20=1;
}	break;
}
while (!(TIFR&(1<<2))          );     
PORTD.1    =1, PORTD.3    =1, PORTB.3    =1;   
}
interrupt [5] void timer1_compa_isr(void)
{
#asm ("wdr")            
F_HalfS=~F_HalfS;       
if (Teplota<SetTemp-1) PORTB.1    =1;
if (Teplota>=SetTemp) PORTB.1    =0;
if (F_NegTemp) PORTB.1    =1;        
if (F_ErrorS) PORTB.1    =0;
if (++CountFiveSek==10) F_FiveSek=1;
if (F_Idle)
{
if (++CountIdle==20) F_IdleS=1;        
}
if (F_Timer)    
{
if (++RunTimer==4) RunTimer=0;
if (++CountTimMin==120)
{
CountTimMin=0;
if (--Timer==0) F_Timer=0, F_Alarm=1;
}
}
else CountTimMin=0;
if (F_Auto)
{
if (F_TempFinish)
{
if (!F_Timer) F_Auto=0, F_TempFinish=0, F_Alarm=1; 
}
else
{
if (!PORTB.1    ) F_TempFinish=1, F_Timer=1, F_Alarm=1;
}
}
if (F_Alarm) PORTB.5    =F_HalfS;  
else PORTB.5    =1;
if (F_Signal)
{
if(!F_Aux_M) PORTB.5    =0, F_Aux_M=1;     
}
else F_Aux_M=0;
}
void Mode2(void)
{
F_Flash=0;
if (!F_Auto)
{
if (F_LongTl) F_Auto=1, Timer=SetTimer;    
else ModeRAM=0;
}
else
{
if (F_LongTl) F_Auto=0, F_TempFinish=0, F_Timer=0;    
}
}
unsigned char Changes (void)
{
while (F_Tl);   
if (!F_LongTl)
{
if (ModeRAM==0) ModeRAM=1;      
else ModeRAM=2;
}
else
{
while (1)
{
if (F_Tl)
{
ChangeNum++;
if (ChangeNum>99) ChangeNum=1;
CountTl=0;
while (F_Tl)  
{
F_NoFlash=1;
if (CountTl==25)        
{
ChangeNum++;
if (ChangeNum>99) ChangeNum=1;
CountTl=0;
}
}
F_NoFlash=0;
}
if (F_FiveSek)
{
if (ModeRAM==1) F_Timer=1, CountTimMin=0, Timer=ChangeNum;        
break;
}
}
}
F_Flash=0;        
return ChangeNum;
}
void Mode1 (void)
{
if (F_Timer)
{
if (F_LongTl) F_Timer=0, F_Flash=0;    
else ModeRAM=0;
}
else
{
ChangeNum=SetTimer;
SetTimer=Changes();
SetTimerEE=SetTimer;
}
}
void Mode0(void)
{
if (!F_ErrorS)
{
ChangeNum=SetTemp;
SetTemp=Changes();
SetTempEE=SetTemp;
}
else
{
ModeRAM=1;      
}
}
void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+
PORTA=0x03;
DDRA=0x03;
PORTB=0xFD;
DDRB=0xBE;
PORTD=0x7F;
DDRD=0x3F;
TCCR0A=0x02;
TCCR0B=0x04;
OCR0A=0x4E;
TCCR1B=0x0B;
OCR1A=39321;    
OCR1B=8200;       
MCUCR=0x20;     
PCMSK=0x01;
TIMSK=0x41;
ACSR=0x80;
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#pragma optsize+

OSCCAL=OSCCAL-5;

if (SetTempEE==0xFF) SetTempEE=20, SetTimerEE=15;      
SetTemp=SetTempEE;
SetTimer=SetTimerEE;
#asm("sei")
while (!PINB.0    )   
{
if (F_LongTl) F_Idle=1, F_Signal=1;
}
while (F_Tl);
F_Signal=0;
while (1)
{
if(F_Alarm)    
{
while(F_Alarm);
while(F_Tl);
}
if (F_Tl)
{
F_LongTl=0;
while (F_Tl)      
{
if (F_LongTl)        
{
F_Flash=1;
break;
}
}
switch (ModeRAM)
{
case 0: Mode0(); break;        
case 1: Mode1(); break;       
case 2: Mode2(); break;         
}
while (F_Tl);   
}
if (F_IdleS)
{
while (F_IdleS)
{
EIFR=0x20;      
TIMSK&=0xFE;    
GIMSK|=0x20;    
#asm ("sleep")  
}
while (!PINB.0    );  
TIMSK|=0x01;    
}
};
}
